package labyrinth.game;

import java.io.IOException;
import java.util.Random;
import java.util.Timer;
import java.util.TimerTask;

import javax.microedition.lcdui.Font;
import javax.microedition.lcdui.Graphics;
import javax.microedition.lcdui.Image;
import javax.microedition.media.Manager;
import javax.microedition.media.MediaException;

import labyrinth.menu.LabyrinthMenu;
import labyrinth.menu.RecordsScreen;
import labyrinth.records.RecordRegistry;
import labyrinth.settings.constants.LabyrinthConstants1;
import labyrinth.settings.constants.LabyrinthConstants2;

import com.nokia.mid.ui.FullCanvas;

public class GameScreen extends FullCanvas {// implements Runnable {

	private LabyrinthMenu main;

	private Game game;

	private Image sprite;

	private Image background;

	private Image fase;

	private Image clock;

	private int x;

	private int y;

	private int xOld;

	private int yOld;

	private Timer t;

	private Counter c;

	public boolean upPressed = false;

	public boolean downPressed = false;

	public boolean rightPressed = false;

	public boolean leftPressed = false;

	//private Thread threadDeRepeticaoDeTecla;

	//private boolean morre;

	private boolean informations;

	public GameScreen(LabyrinthMenu main) {

		try {
			this.main = main;

			//this.morre = false;

			//threadDeRepeticaoDeTecla = new Thread(this);
			//threadDeRepeticaoDeTecla.start();

			//Inicializando a classe Game responsvel pela lgica(controle) do
			// jogo.
			this.game = new Game(this.getInitialLabyrinth());

			this.x = game.getXPosition() * 4;
			this.y = game.getYPosition() * 4;

			//Inicializando as figuras do sprite e do labirinto
			sprite = null;
			background = Image.createImage(this.game.getLabyrinth());
			clock = null;
			fase = null;

			//inicializa o contador
			this.initializeCount();

			informations = true;

			//Pintando a tela
			Timer t = new Timer();
			PaintTimerTask pt = new PaintTimerTask();
			t.schedule(pt, 1200);

		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public GameScreen(LabyrinthMenu main, Game g) {

		try {
			this.main = main;

			//this.morre = false;

			//threadDeRepeticaoDeTecla = new Thread(this);
			//threadDeRepeticaoDeTecla.start();

			//Inicializando a classe Game responsvel pela lgica(controle) do
			// jogo.
			this.game = g;

			this.x = game.getXPosition() * 4;
			this.y = game.getYPosition() * 4;

			if (this.game.isScreen2()) {
				this.x = this.x - 128;
			}

			//Inicializando as figuras do sprite e do labirinto
			sprite = null;
			background = Image.createImage(this.game.getLabyrinth());
			clock = null;
			fase = null;

			//inicializa o contador
			this.initializeCount();

			informations = true;

			//Pintando a tela
			Timer t = new Timer();
			PaintTimerTask pt = new PaintTimerTask();
			t.schedule(pt, 1200);

		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	/*
	 * public void run() { while (!morre) { if (this.upPressed) { this.move(x,
	 * (y - 4), 1); } else if (this.downPressed) { this.move(x, (y + 4), 2); }
	 * else if (this.leftPressed) { this.move((x - 4), y, 3); } else if
	 * (this.rightPressed) { this.move((x + 4), y, 4); } try {
	 * Thread.sleep(100); } catch (InterruptedException e) { //ignore } } }
	 */

	/***************************************************************************
	 * O mtodo paint(Graphics graphics) pinta a tela no visor do aparelho
	 **************************************************************************/
	protected void paint(Graphics graphics) {
		//Runtime.getRuntime().gc();
		try {
			this.sprite = Image.createImage("/labyrinth/images/sprite.png");
			this.clock = Image.createImage("/labyrinth/images/relogio12.png");
			if (!informations) {

				//Labirinto
				if (this.background != null) {
					graphics.setColor(255, 255, 255);
					//graphics.fillRect(0, 0, getWidth(), getHeight());
					if (!this.game.isScreen2()) {
						graphics.drawImage(this.background, 0, 0, Graphics.LEFT
								| Graphics.TOP);
					} else {
						graphics.drawImage(this.background, -128, 0,
								Graphics.LEFT | Graphics.TOP);
					}
					graphics.drawImage(this.clock, 95, 2, Graphics.LEFT
							| Graphics.TOP);
					this.background = null;
					Runtime.getRuntime().gc();
				}

				//Sprite
				graphics.setColor(255, 255, 255);
				graphics.fillRect(this.xOld, this.yOld, 8, 8);
				graphics.drawImage(this.sprite, this.x, this.y, Graphics.LEFT
						| Graphics.TOP);

				//	Vidas
				graphics.setColor(255, 0, 0);
				graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
						Font.STYLE_PLAIN, Font.SIZE_SMALL));
				graphics.drawString("Lives: ", 2, 4, Graphics.LEFT
						| Graphics.TOP);

				int lives = this.game.getLives();
				for (int i = 1; i <= lives; i++) {
					graphics.drawImage(this.sprite, (i * 8) + 28, 4,
							Graphics.LEFT | Graphics.TOP);
				}

				//	pintar o tempo
				graphics.setColor(255, 255, 255);

				graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
						Font.STYLE_PLAIN, Font.SIZE_SMALL));
				graphics.fillRect(110, 4, graphics.getFont().getHeight() * 3,
						graphics.getFont().getHeight());
				graphics.setColor(255, 0, 0);
				graphics.drawString("" + this.game.getTime(), 110, 4,
						Graphics.LEFT | Graphics.TOP);

			} else {
				try {
					this.fase = Image.createImage("/labyrinth/images/fase.png");
					graphics.setColor(255, 255, 255);
					graphics.fillRect(0, 0, getWidth(), getHeight());
					graphics.drawImage(this.fase, 0, 0, Graphics.LEFT
							| Graphics.TOP);
					graphics.setColor(255, 255, 255);

					graphics.setFont(Font.getFont(Font.FACE_SYSTEM,
							Font.STYLE_PLAIN, Font.SIZE_LARGE));
					graphics.drawString("Level " + this.game.getStage(), this
							.getWidth() / 2, this.getHeight() / 2 - 24,
							Graphics.BASELINE | Graphics.HCENTER);
					graphics.drawString("Score " + this.game.getScore(), this
							.getWidth() / 2, this.getHeight() / 2 + 10,
							Graphics.BASELINE | Graphics.HCENTER);
					this.informations = false;
					this.fase = null;
					System.gc();
				} catch (IOException e) {

					e.printStackTrace();
				}

			}
			this.sprite = null;
			this.clock = null;
			System.gc();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	/***************************************************************************
	 * O mtodo keyReleased(int keycode) verifica a acao referente a tecla
	 * soltada.
	 **************************************************************************/
	public void keyReleased(int key) {
		int action = getGameAction(key);
		//this.xOld = x;
		//this.yOld = y;
		switch (action) {
		case UP:
			// cima
			upPressed = false;
			break;
		case KEY_NUM2:
			// cima
			upPressed = false;
			break;
		case DOWN:
			// baixo
			downPressed = false;
			break;
		case KEY_NUM8:
			// baixo
			downPressed = false;
			break;
		case LEFT:
			// esquerda
			leftPressed = false;
			break;
		case KEY_NUM4:
			// esquerda
			leftPressed = false;
			break;
		case RIGHT:
			// direita
			rightPressed = false;
			break;
		case KEY_NUM6:
			// direita
			rightPressed = false;
			break;
		}
		if (key == KEY_SOFTKEY2) {
			this.saveGame();
		}
		//repaint();
	}

	/***************************************************************************
	 * O mtodo keyPressed(int keycode) verifica a acao referente a tecla
	 * pressionada.
	 **************************************************************************/

	public void keyPressed(int key) {
		int action = getGameAction(key);
		this.xOld = this.x;
		this.yOld = this.y;

		switch (action) {
		case UP:
			// cima
			this.move(x, (y - 4), 1);
			upPressed = true;
			break;
		case KEY_NUM2:
			// cima
			this.move(x, (y - 4), 1);
			upPressed = true;
			break;
		case DOWN:
			// baixo
			this.move(x, (y + 4), 2);
			downPressed = true;
			break;
		case KEY_NUM8:
			// baixo
			this.move(x, (y + 4), 2);
			downPressed = true;
			break;
		case LEFT:
			// esquerda
			this.move((x - 4), y, 3);
			leftPressed = true;
			break;
		case KEY_NUM4:
			// esquerda
			this.move((x - 4), y, 3);
			leftPressed = true;
			break;
		case RIGHT:
			// direita
			this.move((x + 4), y, 4);
			rightPressed = true;
			break;
		case KEY_NUM6:
			// direita
			this.move((x + 4), y, 4);
			rightPressed = true;
			break;
		}
		repaint();
	}

	/***************************************************************************
	 * O mtodo move(int x, int y) atualiza a posicao do jogador na tela.
	 **************************************************************************/
	public void move(int x, int y, int direction) {

		if (!this.game.isScreen2()) {

			if (!this.game.colision(x / 4, y / 4, direction, this)) {
				//som do movimento permitido!
				if (this.game.getGameSettings().getSound()
						&& this.game.getTime() > 10) {
					try {
						/*
						 * Sound s = new Sound(30,50,75); Thread t = new
						 * Thread(s); t.start();
						 */
						//Sound.playTone(30, 50, 75);
						Manager.playTone(30, 50, 75);
					} catch (MediaException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
				this.x = (this.game.getXPosition() * 4);
				this.y = this.game.getYPosition() * 4;

			} else {
				//Som de batida na parede!
				if (this.game.getGameSettings().getSound()
						&& this.game.getTime() > 10) {
					//Sound s = new Sound(41,50,100);
					//Thread t = new Thread(s);
					//t.start();
					try {
						Manager.playTone(41, 50, 100);
						//s.playTone(41, 50, 100);
					} catch (MediaException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
				}
			}
		} else {

			if (x < 0) {
				x = 0;
			}
			if (!this.game
					.colision(((x + 128) / 4), ((y / 4)), direction, this)) {

				//som do movimento permitido!
				if (this.game.getGameSettings().getSound()
						&& this.game.getTime() > 10) {
					//Sound s = new Sound(30,50,75);
					//Thread t = new Thread(s);
					//t.start();
					try {
						Manager.playTone(30, 50, 75);
					} catch (MediaException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}

					//s.playTone(30, 50, 75);
				}

				this.x = this.game.getXPosition() * 4;
				this.y = this.game.getYPosition() * 4;

			} else {
				//Som de batida na parede!
				if (this.game.getGameSettings().getSound()
						&& this.game.getTime() > 10) {
					//Sound s = new Sound(41,50,100);
					//Thread t = new Thread(s);
					//t.start();
					try {
						Manager.playTone(41, 50, 100);
						//s.playTone(41, 50, 100);
					} catch (MediaException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
					//s.playTone(41, 50, 100);
				}
			}
		}
		if (this.x >= 128) {
			this.x = this.x - 128;
		}

		if (this.game.winGame()) {
			this.winner();
		} else {
			if (this.game.winLevel()) {
				this.nextLevel();
			}
		}
		//repaint();

	}

	/***************************************************************************
	 * O mtodo loser()
	 **************************************************************************/
	public void loser() {

		if (this.game.getLives() == 0) {
			//this.endGame();
			this.winner();
		} else {
			c.cancel();
			t.cancel();
			this.game.decLives();
			this.game.setScreen2(false);
			this.game.setInitialPositions();
			this.x = game.getXPosition() * 4;
			this.y = game.getYPosition() * 4;
			this.showLevel();
			this.initializeCount();
			try {
				this.background = Image.createImage(this.game.getLabyrinth());
			} catch (IOException e) {

				e.printStackTrace();
			}
			Timer t = new Timer();
			PaintTimerTask pt = new PaintTimerTask();
			t.schedule(pt, 1200);
		}
	}

	/***************************************************************************
	 * O mtodo winner()
	 **************************************************************************/
	public void winner() {
		c.cancel();
		t.cancel();
		this.game.incScore();
		RecordRegistry reg = new RecordRegistry("records");
		boolean temp = reg.isRecord(this.game.getScore());
		if (temp) {
			//aparece a tela de adicionar record;
			RecordsScreen rec = new RecordsScreen(this.main, this.game
					.getScore(), reg);
			//reg.addRecord("nome", this.game.getScore());
		}

		this.game.getGameSettings().setOption(new Integer(0).byteValue());
		this.game.getGameSettings().write();
		this.main.getMain().getDisplay().setCurrent(this.main);
	}

	/***************************************************************************
	 * O mtodo playerWin() mostra a tela de jogo vencido
	 **************************************************************************/
	/*
	 * public void playerWin() { }
	 */

	/***************************************************************************
	 * O mtodo colisionSound() executa o som referente a uma colisao.
	 **************************************************************************/
	/*
	 * public void colisionSound() { }
	 */

	/***************************************************************************
	 * O mtodo showLevel() mostra o level atual.
	 **************************************************************************/
	/***************************************************************************
	 * O mtodo showLevel() mostra o level atual.
	 **************************************************************************/
	public void showLevel() {
		this.informations = true;
		Timer t = new Timer();
		PaintTimerTask pt = new PaintTimerTask();
		t.schedule(pt, 1200);
	}

	/***************************************************************************
	 * O mtodo nextLevel() passa para a tela da proxima fase.
	 **************************************************************************/
	public void nextLevel() {
		c.cancel();
		t.cancel();
		Random randomNumber = new Random();

		int labNumber = Math.abs(randomNumber.nextInt()) % 3;

		this.game.incStage();

		int level = Integer.parseInt("" + this.game.getStage());
		Runtime.getRuntime().gc();
		System.out
				.println("****************************************************level :: "
						+ level);
		try {
			if (level == 2) {
				switch (labNumber) {
				case 0:

					this.game.setLabyrinth(LabyrinthConstants2.LEVEL2a);
					background = Image.createImage(this.game.getLabyrinth());

					//this.game.setTime();
					break;
				case 1:
					this.game.setLabyrinth(LabyrinthConstants2.LEVEL2a);
					//Problemas com esta imagem!! Matriz errada
					//this.game.setLabyrinth(LabyrinthConstants2.LEVEL2b);
					//background = null;
					background = Image.createImage(this.game.getLabyrinth());
					break;
				default:

					this.game.setLabyrinth(LabyrinthConstants2.LEVEL2c);
					//background = null;
					background = Image.createImage(this.game.getLabyrinth());
					break;
				}
			} else {
				if (level == 3) {
					switch (labNumber) {
					case 0:

						this.game.setLabyrinth(LabyrinthConstants1.LEVEL1b);

						//background = null;

						Runtime.getRuntime().gc();

						background = Image
								.createImage(this.game.getLabyrinth());

						break;
					case 1:

						this.game.setLabyrinth(LabyrinthConstants1.LEVEL1b);

						//background = null;

						Runtime.getRuntime().gc();

						background = Image
								.createImage(this.game.getLabyrinth());

						break;
					default:

						this.game.setLabyrinth(LabyrinthConstants1.LEVEL1b);

						//background = null;

						Runtime.getRuntime().gc();

						background = Image
								.createImage(this.game.getLabyrinth());

						break;
					}
				}
			}
			Runtime.getRuntime().gc();
			this.game.incScore();
			this.game.setScreen2(false);

			this.game.incScore();
			this.game.setInitialPositions();
			this.x = this.game.getXPosition() * 4;
			this.y = this.game.getYPosition() * 4;
			this.initializeCount();
		} catch (IOException e) {

			e.printStackTrace();
		}
		this.showLevel();
	}

	/***************************************************************************
	 * O mtodo moveSound(boolean hit) executa ou nao o som de acordo com a
	 * variavel hit passada no parametro.
	 **************************************************************************/
	/*
	 * public void moveSound(boolean hit) { }
	 */

	/***************************************************************************
	 * O mtodo endGame() finaliza o jogo.
	 **************************************************************************/

	public void saveGame() {
		this.c.cancel();
		this.t.cancel();
		this.game.getGameSettings().setMap(this.game.getLabyrinth());
		this.game.getGameSettings().setTime(this.game.getTime());
		this.game.getGameSettings().setScreen2(this.game.isScreen2());
		this.game.getGameSettings().setXPosition(this.game.getXPosition());
		this.game.getGameSettings().setYPosition(this.game.getYPosition());
		this.game.getGameSettings().setStage(this.game.getStage());
		this.game.getGameSettings().setOption(new Integer(1).byteValue());
		this.game.getGameSettings().setLives(
				new Integer(this.game.getLives()).byteValue());
		this.game.getGameSettings().setScore(this.game.getScore());
		this.game.getGameSettings().write();
		this.main.getMain().getDisplay().setCurrent(this.main);
	}

	public void endGame() {
		c.cancel();
		t.cancel();
		this.game.getGameSettings().setOption(new Integer(0).byteValue());
		this.game.getGameSettings().write();
		this.main.getMain().getDisplay().setCurrent(this.main);
	}

	/**
	 * @return Returns the game.
	 */
	public Game getGame() {
		return game;
	}

	/**
	 * @param game
	 *            The game to set.
	 */
	public void setGame(Game game) {
		this.game = game;
	}

	public void initializeCount() {
		t = new Timer();
		c = new Counter(this);
		t.schedule(c, 0, 1000);
	}

	public String getInitialLabyrinth() {
		Random randomNumber = new Random();

		int labNumber = Math.abs(randomNumber.nextInt()) % 3;

		String ret = LabyrinthConstants1.LEVEL1a;
		switch (labNumber) {
		case 0:

			ret = LabyrinthConstants1.LEVEL1a;
			break;
		case 1:

			ret = LabyrinthConstants1.LEVEL1b;
			break;
		default:
			ret = LabyrinthConstants1.LEVEL1b;
			//ret = LabyrinthConstants1.LEVEL1a;
			break;
		}
		return ret;
	}

	private class PaintTimerTask extends TimerTask {
		public final void run() {
			//repaint();
		}
	}

	public void setBackground() {
		try {
			this.background = Image.createImage(this.game.getLabyrinth());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}