package labyrinth.records;

/*
 * Entidade responsvel pela representao de um recorde atravs de uma String
 * que indica o nome do usurio que obteve o recorde e um inteiro que indica a
 * pontuao do mesmo.
 */
public class Record {

	/**
	 * Atributo que armazena o nome do recordista.
	 */
	private String name;

	/**
	 * atributo que armazena a pontuao do recordista.
	 */
	private int score;

	/*COLOCAR NO DIAGRAMA DE CLASSES***************************/
	
	public Record(byte[] data) {
		if (data.length > 0) {
			String temp = new String(data);
			int index = 0;
			while (temp.charAt(index) != '#') {
				index++;
			}
			this.name = temp.substring(0, index);
			this.score = Integer.parseInt(temp.substring(index + 1, temp
					.length()));
		}
		else{
			this.name = "";
			this.score = 0;
		}
	}

	/**
	 * Construtor da classe que instancia um novo objeto inicializando os seus
	 * atributos.
	 * 
	 * @param name
	 *            nome do recordista.
	 * 
	 * @param int
	 *            pontuao do recordista.
	 */
	public Record(String name, int score) {
		this.name = name;
		this.score = score;
	}

	/**
	 * Mtodo que retorna o nome do recordista.
	 * 
	 * @return Returns o nome do recordista.
	 */
	public String getName() {
		return name;
	}

	/**
	 * Mtodo que modifica o nome do recordista.
	 * 
	 * @param name
	 *            o nome que substituir o anterior.
	 */
	public void setName(String name) {
		this.name = name;
	}

	/**
	 * Mtodo que retorna a pontuao do recordista.
	 * 
	 * @return Returns a pontuao do recordista.
	 */
	public int getScore() {
		return score;
	}

	/**
	 * Mtodo que substitui a pontuao do recordista pela score especificado
	 * como parmetro.
	 * 
	 * @param score
	 *            a pontuao que substituir a antiga.
	 */
	public void setScore(int score) {
		this.score = score;
	}	
}